package cn.kdan.pdf.backend.core.params;

import lombok.Data;

import java.util.Date;

/**
 * @author sfq
 * @description
 */
@Data
public class AddAdvertisementParam {

    /**
     * 名称
     */
    private String slug;

    /**
     * 标题
     */
    private String title;

    /**
     * 描述
     */
    private String description;

    /**
     * 图片
     */
    private String image;

    /**
     * 尺寸
     */
    private String dimension;

    /**
     * 链接文案
     */
    private String linkText;

    /**
     * 链接地址
     */
    private String linkUrl;

    /**
     * 语言
     */
    private String language;

    /**
     * 开始日期
     */
    private Date startDate;

    /**
     * 结束日期
     */
    private Date endDate;

    /**
     * 展示类型
     */
    private String displayType;

    /**
     * 开始时间
     */
    private String startHour;

    /**
     * 结束时间
     */
    private String endHour;

    /**
     * 额外信息
     */
    private String extraInfo;

}
