package cn.kdan.pdf.backend.core.service;

import cn.kdan.pdf.backend.core.model.Members;

/**
 * @author : sfq
 * @date : 2023/2/28 14:33
 */
public interface CancelMemberService {

    /**
     * 增加用户注销记录
     * @param members
     */
    void addCancelMember(Members members, String cancelReason);

    /**
     * 判断是否是注销过的用户
     * @param account 账号
     * @param provider 注册方式（phone、email、tencent、wechat）
     * @return true：是注销过的；false：没有注销过
     */
    boolean isCancelMember(String account, String provider);
}
